/* Generated by Together */

import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.tree.*;

/**
 * Erbt von <code>DefaultTreeModel</code> und implementiert dadurch <code>TreeModel</code>.
 * Weitere Infos unter:
 * <a href="http://java.sun.com/docs/books/tutorial/uiswing/components/tree.html">http://java.sun.com/docs/books/tutorial/uiswing/components/tree.html</a>
 * @stereotype control 
 */
public class FAQManagement extends DefaultTreeModel implements Streamable,
    TableModel, TreeModel {
    // Interne Klassenattribute
    private DefaultMutableTreeNode myDummyMoTDTree;
    private FAQNode myFAQTree;
    private FAQNode myCurTopic;                    // Aktuell selektiertes Thema
    private boolean curUserIsAdmin = false;
    
    /**
     * L?dt und initialisiert die FAQ-Struktur.
     * @param ioCtl - Verweist auf ein <code>IOControl</code>-Objekt. Wird zum Laden der FAQ-Struktur verwendet.
     * @see <{FAQTable}>
     * @see <{Streamable}>
     */
    public FAQManagement() {
        super(new DefaultMutableTreeNode("root"));
        
        DefaultMutableTreeNode cr = (DefaultMutableTreeNode) root;
        
        cr.add(myDummyMoTDTree = new DefaultMutableTreeNode("MoTD"));
    }
    
    public void setAdminUser(boolean value) {
        curUserIsAdmin = value;
    }
    
    public void setCurTopic(FAQNode node) {
        if (node != null)
            myCurTopic = node;
    }
    
    public boolean appendFAQTopic(String title) {
        if (myCurTopic == null) return false;

        myCurTopic.add(new FAQNode(title));
        return true;
    }
    
    public String getFAQTopicTitle() {
        if (myCurTopic == null) return "";

        return myCurTopic.getTitle();
    }
    
    public boolean renameFAQTopic(String title) {
        if (myCurTopic == null) return false;

        myCurTopic.setTitle(title);
        return true;
    }
    
    public boolean deleteFAQTopic() {
        if (myCurTopic == null) return false;

        myCurTopic.removeFromParent();
        return true;
    }
    
    public boolean moveFAQTopicUp(){
        if (myCurTopic == null) return false;
        
        FAQNode parent = ((FAQNode)(myCurTopic.getParent()));
        if (parent == null) return false;

        int size = parent.getChildCount();
        int index = getIndexOfChild(parent, myCurTopic);
        
        if (index == 0) return false;
        else {
            removeNodeFromParent(myCurTopic);
            insertNodeInto(myCurTopic, parent, index - 1);
            return true;
        }
    }
      
    public boolean moveFAQTopicDown() {
          if (myCurTopic == null) return false;
          
          FAQNode parent = ((FAQNode)(myCurTopic.getParent()));
          if (parent == null) return false;
          
          int size = parent.getChildCount();
          int index = getIndexOfChild(parent, myCurTopic);
          if (index > size - 2) return false;
          
          removeNodeFromParent(myCurTopic);
          insertNodeInto(myCurTopic, parent, index + 1);
          return true;
    }

    public boolean moveFAQTopicLeft(){
        if (myCurTopic == null) return false;
          
        FAQNode parent = ((FAQNode) (myCurTopic.getParent()));
        if (parent == null) return false;
          
        FAQNode parentPrnt = ((FAQNode) (parent.getParent()));
        if (parentPrnt == null) return false;
          
        int index = parentPrnt.getIndex(parent);
        removeNodeFromParent(myCurTopic);
        insertNodeInto(myCurTopic, parentPrnt, index + 1);
          
        return true;
    }
    
    public boolean moveFAQTopicRight(){
        if (myCurTopic == null) return false;
          
        FAQNode parent = ((FAQNode) (myCurTopic.getParent()));
        if (parent == null) return false;

        int index = parent.getIndex(myCurTopic);
        int size = parent.getChildCount();

        if ((size < 2) || ( index == 0)) return false;

        FAQNode target = ((FAQNode) (parent.getChildAt(index - 1)));
        int tsize = target.getChildCount();
        removeNodeFromParent(myCurTopic);
        insertNodeInto(myCurTopic, target, tsize);

        return true;
    }

    public boolean appendFAQ(String question, String author, String eMail,
        String answer) {
        if (myCurTopic == null) return false;

        return myCurTopic.getFAQList().add(new FAQ(question, author, eMail,
            answer));
    }
    
    public boolean moveFAQUp(int index) {
        if (myCurTopic == null || index < 1) return false;

        Vector v = myCurTopic.getFAQList();
        FAQ object = (FAQ) v.remove(index);
        
        v.insertElementAt(object, index - 1);
        
        return true;
    }
    
    public boolean moveFAQDown(int index) {
        if (myCurTopic == null) return false;

        Vector v = myCurTopic.getFAQList();

        if (index > v.size() - 2) return false;

        FAQ object = (FAQ) v.remove(index);
        v.insertElementAt(object, index + 1);

        return true;
    }

    public boolean moveFAQLeft(int index) {
        if (myCurTopic == null) return false;
          
        FAQNode parent = ((FAQNode) (myCurTopic.getParent()));
        if (parent == null) return false;
        
        FAQ object = ((FAQ) (myCurTopic.getFAQList().remove(index)));
        return parent.getFAQList().add(object);
    }

    public boolean moveFAQRight(int index) {
          if (myCurTopic == null) return false;
          
          int size = myCurTopic.getChildCount();

          FAQNode target = (FAQNode) myCurTopic.getLastChild();
          FAQ object = ((FAQ) (myCurTopic.getFAQList().remove(index)));
          return target.getFAQList().add(object);
      }
      
    /** deleteFAQ() l?scht ein FAQ-Objekt anhand des Indexes
     * @precondition  FAQNotdes-Objekt muss existieren
     * @postcondition Falls zu dem ?bergebenen Index ein MoTD Objekt existierte,
     *                wurde der Verweis aus dem Vector entfernt
     */
    public boolean deleteFAQ(int index) {
        if (myCurTopic == null) return false;

        return myCurTopic.getFAQList().remove(index) != null;
    }
    
    // Interface Streamable
    public void streamIn(IOControl ioCtl) {
        DefaultMutableTreeNode cr = (DefaultMutableTreeNode) root;

        myFAQTree = (FAQNode) ioCtl.readFAQ();

        if (myFAQTree == null)
            myFAQTree = new FAQNode("FAQ");

        cr.add(myFAQTree);
    }
    
    public void streamOut(IOControl ioCtl) {
        ioCtl.writeFAQ(myFAQTree);
    }
    
    // Interface TableModel
    protected EventListenerList listenerList = new EventListenerList();
    
    static final String[] columnNames = {
        "Frage", "Autor", "Email"
    };

    public String getColumnName(int col) { return columnNames[col]; }
    public Class getColumnClass(int col) { return String.class; }

    public int getRowCount() {
        return myCurTopic != null ? myCurTopic.getFAQList().size() : 0;
    }
    
    public int getColumnCount() { return columnNames.length; }

    public boolean isCellEditable(int row, int col) {
        return col == 0 && curUserIsAdmin;
    }
    
    public Object getValueAt(int row, int col) {
        if (myCurTopic == null) return null;
        
        Vector v = myCurTopic.getFAQList();
        if (row < 0 || row >= v.size()) return null;
        
        FAQ faq = (FAQ) v.elementAt(row);
        
        switch (col) {
            case 0: return faq.getQuestion();
            case 1: return faq.getAuthor();
            case 2: return faq.getEMail();
            case 3: return faq.getAnswer();
            default: return null;
        }
    }
    
    public void setValueAt(Object value, int row, int col) {
        if (myCurTopic == null) return;
        
        Vector v = myCurTopic.getFAQList();
        if (row < 0 || row >= v.size()) return;
        
        FAQ faq = (FAQ) v.elementAt(row);
        
        switch (col) {
            case 0:
                faq.setQuestion((String) value);
                break;
            case 1:
                faq.setAuthor((String) value);
                break;
            case 2:
                faq.setEMail((String) value);
                break;
            case 3:
                faq.setAnswer((String) value);
                break;
        }
    }

    public void addTableModelListener(TableModelListener l) {
	listenerList.add(TableModelListener.class, l);
    }

    public void removeTableModelListener(TableModelListener l) {
	listenerList.remove(TableModelListener.class, l);
    }

    public TableModelListener[] getTableModelListeners() {
        return (TableModelListener[])listenerList.getListeners(
                TableModelListener.class);
    }
    /**
     * @label verwaltet
     * @directed
     * @link aggregationByValue
     * @clientCardinality 1
     * @supplierCardinality 1 
     */
    //private FAQTable lnkFAQTable;
}