/*
 * HTMLGenerator.java
 *
 * Created on March 4, 2002, 1:13 PM
 */

/**
 *
 * @author  Tim Frederik Tepasse
 * @version 0.000000000001
 */

// Besser mehr Pakete, als zuwenig....
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

// Transformers!!!!!
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

// Endlich mal was, das wir kennen.
import java.io.*;

public class HTMLGenerator extends java.lang.Object {

    // Createur d'Automobiles.
    public HTMLGenerator() {}

    public boolean generateHTML(String myPath) {
        boolean result = false;
        
        // Global value so it can be ref'd by the tree-adapter
        // static Document document;

        // Deklaration der verschiedenen Dateinamen und -pfade
        File myMOTDFile = new File(myPath + "storage" + File.separator + "motd.xml");
        File myFAQFile  = new File(myPath + "storage" + File.separator + "faq.xml");
        
        File myMOTDTemplate = new File(myPath + "templates" + File.separator + "motd.xsl");
        File myFAQTemplate  = new File(myPath + "templates" + File.separator + "faq.xsl");
        
        File myMOTDOutput = new File(myPath + "output" + File.separator + "motd.html");
        File myFAQOutput  = new File(myPath + "output" + File.separator + "faq.html");
        
        
        // Neue Fabriken fuer die Dokumente erstellen. Sim City!
        DocumentBuilderFactory MOTDFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilderFactory FAQFactory  = DocumentBuilderFactory.newInstance();

        try {
            // Neue DOM-Builder erstellen
            DocumentBuilder MOTDBuilder = MOTDFactory.newDocumentBuilder();
            DocumentBuilder FAQBuilder  = FAQFactory.newDocumentBuilder();
            
            // XML durchparsen und DOM erstellen
            Document MOTDDOM = MOTDBuilder.parse(myMOTDFile);
            Document FAQDOM  = FAQBuilder.parse(myFAQFile);
 
            // Neue Transformer-Fabriken erstellen
            TransformerFactory MOTDTransformerFactory = TransformerFactory.newInstance();
            TransformerFactory FAQTransformerFactory  = TransformerFactory.newInstance();
            
            // Das Stylesheet zum Stroemen bringen
            StreamSource MOTDStyleSource = new StreamSource(myMOTDTemplate);
            StreamSource FAQStyleSource  = new StreamSource(myFAQTemplate);
            
            // Der Transformer auf das Stylesheet konditionieren
            Transformer MOTDTransformer = MOTDTransformerFactory.newTransformer(MOTDStyleSource);
            Transformer FAQTransformer  = FAQTransformerFactory.newTransformer(FAQStyleSource);
            
            // Das DOOM zum Stroemen bringen
            DOMSource MOTDDOMSource = new DOMSource(MOTDDOM);
            DOMSource FAQDOMSource  = new DOMSource(FAQDOM);
            
            // Den Strom des Resultats vorbereiten
            StreamResult MOTDResult = new StreamResult(new BufferedOutputStream(new FileOutputStream(myMOTDOutput)));
            StreamResult FAQResult  = new StreamResult(new BufferedOutputStream(new FileOutputStream(myFAQOutput)));
            
            // Frankenstein voraus!
            // Die vorbereiteten Transformer kriegen das DOM eingestroemt und stroemen
            // das Resultat wieder aus.
            MOTDTransformer.transform(MOTDDOMSource, MOTDResult);
            FAQTransformer.transform(FAQDOMSource, FAQResult);
            
            return true;
        }   
        catch (TransformerConfigurationException tce) {
           // Fehler beim Tranformieren.
           System.out.println ("\n** Fehler in der Transformerfabrik");
           System.out.println("   " + tce.getMessage() );
           
           // Falls etwas auftaucht.
           Throwable x = tce;
           if (tce.getException() != null)
               x = tce.getException();
           x.printStackTrace();
           
           return false;
        }
        catch (TransformerException te) {
           // Die Exception des Transformers
           System.out.println ("\n** Fehler beim Transformieren");
           System.out.println("   " + te.getMessage() );
           
           // Falls etwas auftaucht.
           Throwable x = te;
           if (te.getException() != null)
               x = te.getException();
           x.printStackTrace();
           
           return false;
        }    
        catch (SAXException sxe) {
            // SAX hat Probs.
            Exception  x = sxe;
            if (sxe.getException() != null)
                x = sxe.getException();
            x.printStackTrace();
           
           return false;
        } 
        catch (ParserConfigurationException pce) {
            // Der Parser hat Probs.
            pce.printStackTrace();
           
           return false;
        }
        catch (IOException ioe) {
            // Fehler inner IO
            ioe.printStackTrace();
           
           return false;
        }
    } // Ende der Methode
}
