/*
 * IOControl.java
 *
 * Created on February 28, 2002, 11:36 AM
 */

import java.io.*;
import java.beans.XMLEncoder;
import java.beans.XMLDecoder;

/**
 *
 * @author  sopr151
 * @version 
 */

public class IOControl {
    // Dateinamen
    private String myMoTDFile =  "storage" + File.separator + "motd.xml";
    private String myFAQFile =   "storage" + File.separator + "faq.xml";
    private String myUsersFile = "storage" + File.separator + "users.xml";
    
    // Interne Attribute
    private String myPath;
    
    public IOControl(String path) {
        super();
        myPath = path + File.separator;
    }
    
    private void safeWriteObject(String fileName, Object obj) {
        XMLEncoder enc = null;
        try {
            enc = new XMLEncoder(new BufferedOutputStream(
                new FileOutputStream(myPath + fileName)));
            
            enc.writeObject(obj);
            enc.close();
        }
        catch (Exception e) {
            System.err.println("<" + e.getClass() + ">: "+ e.getMessage());
            System.exit(1);
        }
    }
    
    private Object safeReadObject(String fileName) {
        XMLDecoder dec = null;
        Object result = null;
        
        try {
            dec = new XMLDecoder(new BufferedInputStream(
                new FileInputStream(myPath + fileName)));

            result = dec.readObject();
            dec.close();
        }
        catch (Exception e) {
            System.err.println("<" + e.getClass() + ">: "+ e.getMessage());
            System.exit(1);
        }
        
        return result;
    }
    
    public void writeUsers(Object obj) { safeWriteObject(myUsersFile, obj); }
    public Object readUsers() { return safeReadObject(myUsersFile); }

    public void writeMoTDs(Object obj) { safeWriteObject(myMoTDFile, obj); }
    public Object readMoTDs() { return safeReadObject(myMoTDFile); }

    public void writeFAQ(Object obj) { safeWriteObject(myFAQFile, obj); }
    public Object readFAQ() { return safeReadObject(myFAQFile); }

    public boolean generateHTML() {
        HTMLGenerator HTMLGen = new HTMLGenerator();
        return HTMLGen.generateHTML(myPath);
    }
    
    public String getPath() { return myPath; }
    public String getUsersFile() { return myUsersFile; }
    public String getMoTDFile() { return myMoTDFile; }
    public String getFAQFile() { return myFAQFile; }
}
