/*
 * Benutzerdialog.java
 *
 * Created on February 26, 2002, 2:50 PM
 */

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author  sopr156
 */
public class JAppUserManagementDialog extends JDialog {
    
    private UserManagement myUserManagement;
    private String curUser;
    private int curUserRow = -1;

    /** Creates new form Benutzerdialog */
    public JAppUserManagementDialog(java.awt.Frame parent,
        UserManagement userManagement, String curUserLogin) {
            
        super(parent, true);
        curUser = curUserLogin;
        initComponents();
        
        myUserManagement = userManagement;
        ListViewTable.setModel(myUserManagement);
        ListViewTable.getSelectionModel().addListSelectionListener(
            new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent evt) {
                ListViewTableSelectionChanged(evt);
            }
        });
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        CommandButtonsPanel = new javax.swing.JPanel();
        CloseButton = new javax.swing.JButton();
        DialogInteriorTabbedPane = new javax.swing.JTabbedPane();
        ViewRemoveUserPanel = new javax.swing.JPanel();
        RemoveViewUserPanel = new javax.swing.JPanel();
        ListViewScrollPane = new javax.swing.JScrollPane();
        ListViewTable = new javax.swing.JTable();
        ViewRemoveUserCommandButtonPanel = new javax.swing.JPanel();
        RemoveUserButton = new javax.swing.JButton();
        CreateEditUserPanel = new javax.swing.JPanel();
        CreateEditUserCommandButtonPanel = new javax.swing.JPanel();
        CreateUser = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        EditUserButton = new javax.swing.JButton();
        CreateEditUserDetailsPanel = new javax.swing.JPanel();
        NameLabel = new javax.swing.JLabel();
        NameTextField = new javax.swing.JTextField();
        FirstnameLabel = new javax.swing.JLabel();
        FirstnameTextField = new javax.swing.JTextField();
        EmailLabel = new javax.swing.JLabel();
        EmailTextField = new javax.swing.JTextField();
        LoginLabel = new javax.swing.JLabel();
        LoginTextField = new javax.swing.JTextField();
        PasswordLabel = new javax.swing.JLabel();
        PasswordPasswordField = new javax.swing.JPasswordField();
        CategoryLabel = new javax.swing.JLabel();
        CategoryComboBox = new javax.swing.JComboBox();
        
        setTitle("Benutzer Verwalten");
        setBackground(new java.awt.Color(212, 208, 200));
        setFont(new java.awt.Font("Dialog", 0, 11));
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        CommandButtonsPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));
        
        CommandButtonsPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 0, 8, 8)));
        CommandButtonsPanel.setPreferredSize(new java.awt.Dimension(338, 34));
        CloseButton.setBackground(new java.awt.Color(212, 208, 200));
        CloseButton.setFont(new java.awt.Font("Dialog", 0, 11));
        CloseButton.setText("Schlie\u00dfen");
        CloseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CloseButtonActionPerformed(evt);
            }
        });
        
        CommandButtonsPanel.add(CloseButton);
        
        getContentPane().add(CommandButtonsPanel, java.awt.BorderLayout.SOUTH);
        
        DialogInteriorTabbedPane.setBackground(new java.awt.Color(204, 204, 204));
        DialogInteriorTabbedPane.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        DialogInteriorTabbedPane.setFont(new java.awt.Font("Dialog", 0, 11));
        DialogInteriorTabbedPane.setPreferredSize(new java.awt.Dimension(520, 303));
        ViewRemoveUserPanel.setLayout(new java.awt.BorderLayout());
        
        RemoveViewUserPanel.setLayout(new java.awt.BorderLayout());
        
        RemoveViewUserPanel.setBackground(new java.awt.Color(212, 208, 200));
        RemoveViewUserPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        RemoveViewUserPanel.setFont(new java.awt.Font("Dialog", 0, 11));
        ListViewScrollPane.setBackground(java.awt.Color.white);
        ListViewScrollPane.setPreferredSize(new java.awt.Dimension(520, 200));
        ListViewTable.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        ListViewTable.setFont(new java.awt.Font("Dialog", 0, 11));
        ListViewTable.setMaximumSize(new java.awt.Dimension(2147483647, 2147483647));
        ListViewTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        ListViewTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ListViewTableMouseClicked(evt);
            }
        });
        
        ListViewScrollPane.setViewportView(ListViewTable);
        
        RemoveViewUserPanel.add(ListViewScrollPane, java.awt.BorderLayout.CENTER);
        
        ViewRemoveUserPanel.add(RemoveViewUserPanel, java.awt.BorderLayout.CENTER);
        
        ViewRemoveUserCommandButtonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));
        
        ViewRemoveUserCommandButtonPanel.setBackground(new java.awt.Color(212, 208, 200));
        ViewRemoveUserCommandButtonPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 0, 8, 8)));
        RemoveUserButton.setBackground(new java.awt.Color(212, 208, 200));
        RemoveUserButton.setFont(new java.awt.Font("Dialog", 0, 11));
        RemoveUserButton.setText("Benutzer entfernen");
        RemoveUserButton.setEnabled(false);
        RemoveUserButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveUserButtonActionPerformed(evt);
            }
        });
        
        ViewRemoveUserCommandButtonPanel.add(RemoveUserButton);
        
        ViewRemoveUserPanel.add(ViewRemoveUserCommandButtonPanel, java.awt.BorderLayout.SOUTH);
        
        DialogInteriorTabbedPane.addTab("Benutzer anzeigen/entfernen", ViewRemoveUserPanel);
        
        CreateEditUserPanel.setLayout(new java.awt.BorderLayout());
        
        CreateEditUserPanel.setBackground(new java.awt.Color(212, 208, 200));
        CreateEditUserPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        CreateEditUserCommandButtonPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));
        
        CreateEditUserCommandButtonPanel.setBackground(new java.awt.Color(212, 208, 200));
        CreateEditUserCommandButtonPanel.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 0, 0, 0)));
        CreateUser.setBackground(new java.awt.Color(212, 208, 200));
        CreateUser.setFont(new java.awt.Font("Dialog", 0, 11));
        CreateUser.setText("Anlegen");
        CreateUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CreateUserActionPerformed(evt);
            }
        });
        
        CreateEditUserCommandButtonPanel.add(CreateUser);
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(8, 0));
        CreateEditUserCommandButtonPanel.add(jSeparator1);
        
        EditUserButton.setBackground(new java.awt.Color(212, 208, 200));
        EditUserButton.setFont(new java.awt.Font("Dialog", 0, 11));
        EditUserButton.setText("Uebernehmen");
        EditUserButton.setEnabled(false);
        EditUserButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditUserButtonActionPerformed(evt);
            }
        });
        
        CreateEditUserCommandButtonPanel.add(EditUserButton);
        
        CreateEditUserPanel.add(CreateEditUserCommandButtonPanel, java.awt.BorderLayout.SOUTH);
        
        CreateEditUserDetailsPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        CreateEditUserDetailsPanel.setBackground(new java.awt.Color(212, 208, 200));
        NameLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        NameLabel.setText("Name:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(NameLabel, gridBagConstraints1);
        
        NameTextField.setFont(new java.awt.Font("Dialog", 0, 11));
        NameTextField.setPreferredSize(new java.awt.Dimension(160, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(NameTextField, gridBagConstraints1);
        
        FirstnameLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        FirstnameLabel.setText("Vorname:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(FirstnameLabel, gridBagConstraints1);
        
        FirstnameTextField.setFont(new java.awt.Font("Dialog", 0, 11));
        FirstnameTextField.setPreferredSize(new java.awt.Dimension(160, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(FirstnameTextField, gridBagConstraints1);
        
        EmailLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        EmailLabel.setText("Email:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(EmailLabel, gridBagConstraints1);
        
        EmailTextField.setFont(new java.awt.Font("Dialog", 0, 11));
        EmailTextField.setPreferredSize(new java.awt.Dimension(160, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(EmailTextField, gridBagConstraints1);
        
        LoginLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        LoginLabel.setText("Login:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(LoginLabel, gridBagConstraints1);
        
        LoginTextField.setFont(new java.awt.Font("Dialog", 0, 11));
        LoginTextField.setPreferredSize(new java.awt.Dimension(96, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(LoginTextField, gridBagConstraints1);
        
        PasswordLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        PasswordLabel.setText("Passwort:");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(PasswordLabel, gridBagConstraints1);
        
        PasswordPasswordField.setFont(new java.awt.Font("Dialog", 0, 11));
        PasswordPasswordField.setPreferredSize(new java.awt.Dimension(96, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(PasswordPasswordField, gridBagConstraints1);
        
        CategoryLabel.setFont(new java.awt.Font("Dialog", 0, 11));
        CategoryLabel.setText("Kategorie");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.ipadx = 10;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(CategoryLabel, gridBagConstraints1);
        
        CategoryComboBox.setBackground(new java.awt.Color(212, 208, 200));
        CategoryComboBox.setFont(new java.awt.Font("Dialog", 0, 11));
        CategoryComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Gruppenbetreuer", "Verwalter" }));
        CategoryComboBox.setPreferredSize(new java.awt.Dimension(128, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        CreateEditUserDetailsPanel.add(CategoryComboBox, gridBagConstraints1);
        
        CreateEditUserPanel.add(CreateEditUserDetailsPanel, java.awt.BorderLayout.CENTER);
        
        DialogInteriorTabbedPane.addTab("Benutzer anlegen/\u00e4ndern", CreateEditUserPanel);
        
        getContentPane().add(DialogInteriorTabbedPane, java.awt.BorderLayout.CENTER);
        
        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension dialogSize = getSize();
        setLocation((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
    }//GEN-END:initComponents

    // Fuer Eingabevalidierung
    private final Color red = new Color(255, 128, 128);
    private final Color white = new Color(255, 255, 255);
    private boolean err;

    private String visualValidateField(JTextField field) {
        String r = field.getText();
        
        if (r.equals("")) {
            field.setBackground(red);
            err = true;
        } else
            field.setBackground(white);

        return r;
    }

    private void EditUserButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditUserButtonActionPerformed
        err = false;
        String name = visualValidateField(NameTextField);
        String firstName = visualValidateField(FirstnameTextField);
        String eMail = visualValidateField(EmailTextField);
        String login = visualValidateField(LoginTextField);
        String password = visualValidateField(PasswordPasswordField);
        
        if (err)
            JOptionPane.showMessageDialog(null, "Bitte fuellen Sie die rot " +
                "unterlegten Felder aus, um die Benutzerdaten zu uebernehmen.",
                "SoPra Content-Management", JOptionPane.INFORMATION_MESSAGE);
        else {
            ListSelectionModel lsm = ListViewTable.getSelectionModel();

            // Wir wissen, dass ein Eintrag selektiert ist
            int selectedRow = lsm.getMinSelectionIndex();

            myUserManagement.setValueAt(name, selectedRow, 0);
            myUserManagement.setValueAt(firstName, selectedRow, 1);
            myUserManagement.setValueAt(eMail, selectedRow, 2);
            myUserManagement.setValueAt(login, selectedRow, 3);
            
            if (selectedRow != curUserRow)
                myUserManagement.setValueAt(
                    new Boolean(CategoryComboBox.getSelectedIndex() == 1),
                    selectedRow, 4);
            else 
                curUser = login;
            myUserManagement.setValueAt(password, selectedRow, 5);

            ListViewTable.updateUI();
        }
    }//GEN-LAST:event_EditUserButtonActionPerformed

    private void CreateUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CreateUserActionPerformed
        err = false;
        String name = visualValidateField(NameTextField);
        String firstName = visualValidateField(FirstnameTextField);
        String eMail = visualValidateField(EmailTextField);
        String login = visualValidateField(LoginTextField);
        String password = visualValidateField(PasswordPasswordField);
        
        if (err)
            JOptionPane.showMessageDialog(null, "Bitte fuellen Sie die rot " +
                "unterlegten Felder aus, um einen Benutzer anzulegen.",
                "SoPra Content-Management", JOptionPane.INFORMATION_MESSAGE);
        else if (myUserManagement.existUser(login))
            JOptionPane.showMessageDialog(null, "Benutzer konnte nicht " +
                "angelegt werden, da bereits ein Konto mit dem angegebenen " +
                "Loginnamen existiert.",
                "SoPra Content-Management", JOptionPane.INFORMATION_MESSAGE);
        else if (myUserManagement.createUser(name, firstName, eMail, login, password,
            CategoryComboBox.getSelectedIndex() == 1)) { // Erfolgreich erzeugt
            NameTextField.setText("");
            FirstnameTextField.setText("");
            EmailTextField.setText("");
            LoginTextField.setText("");
            PasswordPasswordField.setText("");
        } else // nicht erfolgreich angelegt
            JOptionPane.showMessageDialog(null, "Benutzer konnte nicht " +
                "angelegt werden.\nUeberpruefen Sie, ob genuegend Speicherplatz" +
                "zur Verfuegung steht.",
                "SoPra Content-Management", JOptionPane.INFORMATION_MESSAGE);

        ListViewTable.updateUI();
    }//GEN-LAST:event_CreateUserActionPerformed

    private void RemoveUserButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveUserButtonActionPerformed
        ListSelectionModel lsm = ListViewTable.getSelectionModel();
        if (!lsm.isSelectionEmpty() &&
            JOptionPane.showConfirmDialog(null, "Benutzer loeschen?",
                "SoPra Content-Management", JOptionPane.YES_NO_OPTION) ==
                JOptionPane.YES_OPTION
        ) {
            int selectedRow = lsm.getMinSelectionIndex();
            myUserManagement.deleteUser((String) myUserManagement.getValueAt(
                selectedRow, 3));
            ListViewTable.updateUI();
        }
    }//GEN-LAST:event_RemoveUserButtonActionPerformed

    private void ListViewTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ListViewTableMouseClicked
        if (evt.getClickCount() == 2) // Double-Click
            DialogInteriorTabbedPane.setSelectedIndex(1);
    }//GEN-LAST:event_ListViewTableMouseClicked

    public String getCurLogin() {
        return curUser;
    }
    
    private void ListViewTableSelectionChanged(ListSelectionEvent evt) {
        ListSelectionModel lsm = (ListSelectionModel) evt.getSource();

        EditUserButton.setEnabled(!lsm.isSelectionEmpty());

        // ?berfl?ssige Ereignisse ignorieren
        if (evt.getValueIsAdjusting()) return;

        if (!lsm.isSelectionEmpty()) {
            int selectedRow = lsm.getMinSelectionIndex();
            
            NameTextField.setText(        (String) myUserManagement.getValueAt(selectedRow, 0));
            FirstnameTextField.setText(   (String) myUserManagement.getValueAt(selectedRow, 1));
            EmailTextField.setText(       (String) myUserManagement.getValueAt(selectedRow, 2));
            LoginTextField.setText(       (String) myUserManagement.getValueAt(selectedRow, 3));
            PasswordPasswordField.setText((String) myUserManagement.getValueAt(selectedRow, 5));
            CategoryComboBox.setSelectedIndex(
                ((String) myUserManagement.getValueAt(
                    selectedRow, 4)).equals("Verwalter") ?
                    1 /* Verwalter */ : 0 /* Gruppenbetreuer */
            );
            
            boolean curUserSel = LoginTextField.getText().equals(curUser);
            RemoveUserButton.setEnabled(!curUserSel);
            
            if (curUserSel) curUserRow = selectedRow;
        } else
            RemoveUserButton.setEnabled(false);
    }
    
    private void CloseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CloseButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_CloseButtonActionPerformed

    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
    }//GEN-LAST:event_closeDialog

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel CommandButtonsPanel;
    private javax.swing.JButton CloseButton;
    private javax.swing.JTabbedPane DialogInteriorTabbedPane;
    private javax.swing.JPanel ViewRemoveUserPanel;
    private javax.swing.JPanel RemoveViewUserPanel;
    private javax.swing.JScrollPane ListViewScrollPane;
    private javax.swing.JTable ListViewTable;
    private javax.swing.JPanel ViewRemoveUserCommandButtonPanel;
    private javax.swing.JButton RemoveUserButton;
    private javax.swing.JPanel CreateEditUserPanel;
    private javax.swing.JPanel CreateEditUserCommandButtonPanel;
    private javax.swing.JButton CreateUser;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton EditUserButton;
    private javax.swing.JPanel CreateEditUserDetailsPanel;
    private javax.swing.JLabel NameLabel;
    private javax.swing.JTextField NameTextField;
    private javax.swing.JLabel FirstnameLabel;
    private javax.swing.JTextField FirstnameTextField;
    private javax.swing.JLabel EmailLabel;
    private javax.swing.JTextField EmailTextField;
    private javax.swing.JLabel LoginLabel;
    private javax.swing.JTextField LoginTextField;
    private javax.swing.JLabel PasswordLabel;
    private javax.swing.JPasswordField PasswordPasswordField;
    private javax.swing.JLabel CategoryLabel;
    private javax.swing.JComboBox CategoryComboBox;
    // End of variables declaration//GEN-END:variables

}
