/* Generated by Together */

/**
 * Interface zur Vereinheitlichung des Streaming-Prozesses ?ber <code>IOControl</code>.
 * Eingef?hrt, damit man die einzelnen Management-Klassen nicht kennen muss, um sie in den Stream zu schreiben.
 * @version 1.0
 * @author Christian Blichmann
 * @see UserManagement
 * @see MoTDManagement
 * @see FAQManagement 
 */
public interface Streamable {
    /**
     * L?dt das Objekt, dessen Klasse das <code>Streamable</code>-Interface implementiert, aus dem Stream.
     * @return void
     * @param ioCtl - Referenz auf eine Instanz von <code>IOControl</code>
     * @see IOControl
     * pre: Das Objekt in ioCtl muss existieren und initialisiert sein
     * post: Die Instanz der Klasse, die Streamable implementiert wurde geladen
     */
    void streamIn(IOControl ioCtl);

    /**
     * Speichert das Objekt, dessen Klasse das <code>Streamable</code>-Interface implementiert, in den Stream.
     * @return void
     * @param ioCtl - Referenz auf eine Instanz von <code>IOControl</code>
     * @see IOControl 
     * pre: Das Objekt in ioCtl muss existieren und initialisiert sein
     * post: Die Instanz der Klasse, die Streamable implementiert wurde gespeichert
     */
    void streamOut(IOControl ioCtl);
}
