/* Generated by Together */
import java.io.*;
import java.util.*;
import javax.swing.table.*;
import javax.swing.table.AbstractTableModel;

/**
 * @stereotype entity
 */
public class UserTable extends Vector implements Serializable {
    // Erzeugt ein Vector Objekt UserTable mit dem Konstruktoraufruf der Oberklasse
    public UserTable() {
        super(0);
    }
    
    /**
     * Erzeugt einen neuen Benutzer.
     * @param name - Nachname
     * @param firstName - Vorname
     * @param eMail - Emailadresse
     * @param login - Loginname
     * @param password - Passwort
     * @param adminUser - Verwalter oder nicht
     * @return <code>true</code> wenn erfolgreich und Benutzer noch nicht
     *         vorhanden, <code>false</code> sonst 
     * pre: Alle Parameter muessen ausgefuellt sein
     * post: Es wurde ein Benutzer angelegt
     */
    public boolean createUser(String name, String firstName, String eMail,
        String login, String password, boolean adminUser) {
        return add(new User(name, firstName, eMail, login, password, adminUser));
    }

    /**
     * L?scht einen Benutzer.
     * @return <code>true</code> wenn Benutzer gel?scht, <code>false</code> wenn
     *         Benutzer nicht vorhanden oder letzter/aktueller Benutzer. 
     * pre: Benutzer mit Loginname login muss existieren
     * post: Der Benutzer wurde entfernt
     */
    public boolean deleteUser(String login) {
        boolean del = remove(findUser(login));
        trimToSize();
        
        return del;
    }

    /* L?uft den Vector ab. Castet das Ergebniss von elementAt in User,
     * ?berprueft, ob der login des Objekts dem Login-String entspricht,
     * gibt den User (gecastet) oder null zur?ck.
     * pre: login muss ausfeuellt sein
     * post: Benutzer wurde gefunden, oder nicht
     */
    public User findUser(String login) {
        for (int i = 0; i < size(); i++)
            if (((User)(elementAt(i))).getLogin().equals(login))
              return (User)(elementAt(i));

        return null;
    }

    /* pre: Benutzer mit Loginname login muss existieren
     * post: Benutzer ist Verwalter oder nicht
     */
    public boolean isAdminUser(String login) {
        return findUser(login).isAdminUser();
    }

    /**
     * @link aggregationByValue
     * @clientCardinality 1
     * @supplierCardinality 0..*
     * @label verwaltet 
     */
    //private User lnkUser;
}